package sendsms;

import java.io.*;
import java.net.*;

public class SendSMS {
    public static void main(String[] args) throws UnsupportedEncodingException {
        //-------------------------------------------------------//
        //  PASO 1: Definir las variables requeridas             // 
        //-------------------------------------------------------//
        URL u;
        InputStream is = null;
        DataInputStream dis;
        String s;
        //-------------------------------------------------------//
        //  PASO 2: Definir los parametros de acceso a la cuenta //
        //-------------------------------------------------------//
        String api_id = "su_company_id";
        String user_id = "su_user_id";
        String password = "su_contraseña";
        String telefono = "3001234567";
        String telefono_completo = "57" + telefono;
        String texto = "Probando integración en Java mediante el uso de la Gateway SMS";

        //-------------------------------------------------------//
        //  PASO 3: Definir la URL de la API HTTP                //
        //-------------------------------------------------------//
        String requestUrl  = "http://www.linktosmsc.com/massms/api/sendmsg.php?api_id=" + URLEncoder.encode(api_id, "ISO-8859-1") +
                             "&user=" + URLEncoder.encode(user_id, "ISO-8859-1") +
                             "&password=" + URLEncoder.encode(password, "ISO-8859-1") +
                             "&to=" + URLEncoder.encode(telefono_completo, "ISO-8859-1") +
                             "&text=" + URLEncoder.encode(texto, "ISO-8859-1");

        //-------------------------------------------------------//
        //  PASO 4: Realizar la conexion HTTP                    //
        //-------------------------------------------------------//
        try {
            u = new URL(requestUrl);
            //---------------------------------------------------//
            //  PASO 5: Abrir un stream de entrada para la URL   //
            //---------------------------------------------------//
            is = u.openStream();         

            //-------------------------------------------------------------//
            // PASO 6:                                                     //
            //-------------------------------------------------------------//
            // Convertir el InputStream a un búfer DataInputStream         //
            // Crear un Búfer de la secuencia hace la lectura más rápida,  //
            // y el método readLine() de DataInputStream la hace la        //
            // lectura más fácil.                                          //
            //-------------------------------------------------------------//
            dis = new DataInputStream(new BufferedInputStream(is));

            //-------------------------------------------------------------//
            // PASO 7:                                                     //
            //-------------------------------------------------------------//
            // Finalmente, leemos cada cada registro del flujo de entrada, //
            // y lo mostramos en pantalla.                                 //
            // Tenga en cuenta que se asume que este ejemplo se ejecuta    //
            // desde la línea de comandos, no desde una aplicación o       //
            // applet. Allí la impresión de los datos debe realizarse      //
            // de acuerdo al método que esté utilizando                    //
            //-------------------------------------------------------------//
            while ((s = dis.readLine()) != null) {
                //---------------------------------------------------------//
                //  Paso 8: Obtener e imprimir el resultado del envio      //
                //---------------------------------------------------------//
                String[] msgData = s.split(":");
                System.out.println("Numero de telefono: " + msgData[0]);
                System.out.println("ID del mensaje: " + msgData[1]);
            }
			
			/* En java 8 se debe hacer de la siguiente manera: */
			    String requestUrl = "http://www.linktosmsc.com/massms/api/sendmsg.php?api_id=" + URLEncoder.encode(api_id, "ISO-8859-1") +
									"&user=" + URLEncoder.encode(user_id, "ISO-8859-1") +
									"&password=" + URLEncoder.encode(password, "ISO-8859-1") +
									"&to=" + URLEncoder.encode(telefono_completo, "ISO-8859-1") +
									"&text=" + URLEncoder.encode(texto, "ISO-8859-1");			

				StringBuilder s = new StringBuilder();
				URLConnection urlConn = null;
				InputStreamReader in = null;
				try {
					URL url = new URL(requestUrl);
					urlConn = url.openConnection();
					if (urlConn != null)
						urlConn.setReadTimeout(60 * 1000);
					if (urlConn != null && urlConn.getInputStream() != null) {
						in = new InputStreamReader(urlConn.getInputStream(),
								Charset.defaultCharset());
						BufferedReader bufferedReader = new BufferedReader(in);
						if (bufferedReader != null) {
							int cp;
							while ((cp = bufferedReader.read()) != -1) {
								s.append((char) cp);
							}
							bufferedReader.close();
						}
					}

					String[] msgData = s.split(":");
					System.out.println("Numero de telefono: " + msgData[0]);
					System.out.println("ID del mensaje: " + msgData[1]);

					in.close();
				} catch (Exception e) {
					throw new RuntimeException("Exception while calling URL:"+ myURL, e);
				} 
			/* ******************************************* */
			
        } catch (MalformedURLException mue) {
            System.out.println("Atención! Se ha detectado un error al definir la URL.");
            mue.printStackTrace();
            System.exit(1);
        } catch (IOException ioe) {
            System.out.println("Atención se ha generado un error de entrada/salida [IOException]");
            ioe.printStackTrace();
            System.exit(1);
        } finally {
            //---------------------------------//
            // Paso 9: cerrar el InputStream   //
            //---------------------------------//

            try {
                is.close();
            } catch (IOException ioe) { }
        } 
    }    
}